// --------------------------------
// File    : ClientPlayer.h
// Function: Client-side class for controlling a player object and a camera.
//         : Fairly simplistic.
// --------------------------------

#ifndef __CLIENTPLAYER_H
#define __CLIENTPLAYER_H

#include "lokicam.h"

class ClientPlayer
{
	protected:
		HSTRING		m_hName;	// Hey...nice for doing the 'personalized' demo bit.
		HLOCALOBJ	m_hCamera;	// Handle to camera.
		ClientDE	*m_pClient; // Handle to ClientDE.

		float		  m_Yaw, m_Pitch, m_Roll;
		float         m_cYaw, m_cPitch, m_cRoll;

		DBOOL         m_bCameraLocked;
		float         m_fDistance, m_fOffset;
		LokiCam       m_LokiCam;

	public:
		ClientPlayer();
		~ClientPlayer();

		void		Init(ClientDE *pClient);

		HLOCALOBJ	GetCamera() { return m_LokiCam.GetCamera(); };
		ClientDE*   GetClient() { return m_pClient; };

		void		SetCamera(HLOCALOBJ hObj) { m_LokiCam.SetCamera(hObj); };
		void		ResetCamera();

		void		Update();
		void		OnCommandOn(int command);
};

#endif // __CLIENTPLAYER_H