
// --------------------------------
// File    : EffectManager.h
// Function: Handles the various special effects; adding, removing and updating them
//         : as appropriate.
// --------------------------------


#ifndef __EFFECTMANAGER_H
#define __EFFECTMANAGER_H

#include "effect.h"

class EffectManager
{
	protected:
		Effect			*m_pEffects;
		ClientPlayer	*m_pPlayer;

	public:
		EffectManager() { m_pEffects = NULL; m_pPlayer = NULL; };
		~EffectManager() { DestroyAll(); }

		void Init(ClientPlayer *pPlayer) { m_pPlayer = pPlayer; };
		void Handler(HLOCALOBJ hObj, HMESSAGEREAD hMessage);
		void Update();
		void DestroyAll();

	private:
		void AddEffect(Effect *pEffect);
		void DelEffect(Effect *pEffect);
};

#endif // __EFFECTMANAGER_H