
// --------------------------------
// File    : PolyGrid.h
// Function: C++ class definition for the polygrid (water) effect for the Lithtech demo
//         : Special thanks to Kevin Stephens (of the Riot: Mobile Armor team)
//         : for the use of his polygrid class as the basis for this one.
// --------------------------------


#ifndef __POLYGRID_H
#define __POLYGRID_H

#include "de_client.h"
#include "effect.h"

typedef struct
{
	DVector m_Color;
	int m_Index;
} ColorRamp;

class PolyGrid : public Effect
{
	public:

		PolyGrid();
		~PolyGrid() { Destroy(); };

		virtual DBOOL	Init(ClientPlayer *pPlayer, HLOCALOBJ hObj, DBYTE byType, HMESSAGEREAD hMessage);

		virtual DBOOL	Update();
		virtual void	Destroy();

	protected:

		DBOOL CreateObject(ClientDE *pClientDE);

		void PrecalculatePlasma();
		void SetPolyGridPalette(ColorRamp *pRamps, int nRamps);
		void UpdatePlasma();
		void UpdateSurface();

	private :

		// Plasma stuff.
		DBYTE		*m_DistanceGrid;
		float		m_fCount;		
		DBOOL		m_bScalingXUp;
		DBOOL		m_bScalingYUp;

		DVector		m_vDims;
		DVector		m_vColor1;
		DVector		m_vColor2;
		DFLOAT		m_fXScaleMin; 
		DFLOAT		m_fXScaleMax; 
		DFLOAT		m_fYScaleMin; 
		DFLOAT		m_fYScaleMax; 
		DFLOAT		m_fXScaleDuration;
		DFLOAT		m_fYScaleDuration;
		DFLOAT		m_fXPan;
		DFLOAT		m_fYPan;
		HSTRING		m_hstrSurfaceSprite;
		DBOOL		m_bTransparent;
		DDWORD		m_dwNumPolies;

};


#endif // __POLYGRID_H