
#ifndef __TORCH_H
#define __TORCH_H

#include "effect.h"
#include "de_client.h"

class Torch : public Effect {
protected:
	float			m_fCycle;
	HLOCALOBJ		m_hParticles;
	HLOCALOBJ		m_hLight;
	int				m_bInited;
	float			m_LightRadius, m_LightDuration;

	ClientDE		*m_pClient;
	DBOOL			m_bSpiral;

	// Spiral flame info
	DVector m_center_Pos; // Where the torchfx is
	DVector m_center2_Pos; // Offset for second helical path
	float m_Rad1, m_Rad2; // Attractor Path Radii
	int m_spiral1_Rate, m_spiral2_Rate;// Attractor Path rates
	double m_Phase1, m_Phase2; // So that they don't all cycle the same

	void	StartSystem(ClientDE *pClient, DVector *mainpos, float lightradius, float lightduration, 
				DVector center2, float Rad1, float Rad2, int spiral1, int spiral2, 
				double Phase1, double Phase2, DBOOL complex);

	void	DestroySystem();

public:

	Torch() { m_bInited = 0; m_fCycle = 0.0; m_bSpiral = DFALSE; };
	~Torch() { DestroySystem(); };

	virtual DBOOL	Init(ClientPlayer *pPlayer, HLOCALOBJ hObj, DBYTE byType, HMESSAGEREAD hMessage);

	DBOOL	Update();
	void	Destroy() { DestroySystem(); }

	int		IsInited() { return m_bInited; };
	
};


#endif // __LOKIPARTICLE_H