
// --------------------------------
// File    : c_lensflare.h
// Function: C include file for actual LensFlare effect, wrapped by LensFlare.cpp.
//         : Provided as an example of how to manipulate engine data under C as
//         : well. :)
//         : Special thanks to Mike Dussault for the original base code for the flare.
// --------------------------------


#ifndef __C_LENSFLARE_H__
#define __C_LENSFLARE_H__


	#include "dlink.h"


	typedef void* HLENSFLARE;

	
	// Create and destroy flares.
	HLENSFLARE lf_CreateFlare(ClientDE *pClientDE, HLOCALOBJ hObj);
	void lf_DestroyFlare(ClientDE *pClientDE, HLENSFLARE hFlare);
	
	// Update the flare every frame.
	void lf_UpdateFlare(ClientDE *pClientDE, HLENSFLARE hFlare, HLOCALOBJ hViewer);

	// Hide the flare.
	void lf_HideFlare(ClientDE *pClientDE, HLENSFLARE hFlare);
	
	// Get its DLink so you can store them in a list.
	// The DLink's m_pData is the HLENSFLARE.
	struct DLink_t* lf_GetFlareLink(HLENSFLARE hFlare);


#endif  // __C_LENSFLARE_H__


