// --------------------------------
// File    : WaterSpraySource.h
// Function: Dummy object used as the location/dimensions for the
//         : waterspray client-side effect.
// --------------------------------

#include <stdio.h>

#include "de_server.h"
#include "waterspraysource.h"
#include "demo_msgtypes.h"

// Our simple waterspray source object

DDWORD WaterSpraySource::EngineMessageFn(DDWORD messageID, void *pData, DFLOAT lData)
{
	HMESSAGEWRITE hWrite;

	switch(messageID)
	{
		// This is where the variables from the level editor are read.
		case MID_PRECREATE:
		{
			GenericProp gProp;
			
			if (GetServerDE()->GetPropGeneric("Dims",&gProp) == DE_OK)
				m_vDims = gProp.m_Vec;
			else
				VEC_SET(m_vDims,1.0f,1.0f,1.0f);

			if (GetServerDE()->GetPropGeneric("Thickness",&gProp) == DE_OK)
				m_byThick = (DBYTE)gProp.m_Long;
			else
				m_byThick = 20;

			break;
		}

		// Our initial update.. 
		// Setup the special effect message.
		case MID_INITIALUPDATE:
		{
			// Send all our relevant data to the client.
			hWrite = GetServerDE()->StartSpecialEffectMessage(this);
			GetServerDE()->WriteToMessageByte(hWrite, DEMO_MSG_WATERSPRAY_ADD);
			GetServerDE()->WriteToMessageVector(hWrite, &m_vDims);
			GetServerDE()->WriteToMessageByte(hWrite, m_byThick);
			GetServerDE()->EndMessage(hWrite);
			break;
		}
	}

	// Pass the message on down to our parent.
	return BaseClass::EngineMessageFn(messageID, pData, lData);
}

// Class definition.
BEGIN_CLASS(WaterSpraySource)
ADD_VECTORPROP_FLAG(Dims, PF_DIMS|PF_LOCALDIMS)
ADD_LONGINTPROP(Thickness,50)
END_CLASS_DEFAULT(WaterSpraySource, BaseClass, NULL, NULL)
