// --------------------------------
// File    : LensFlareSource.cpp
// Function: Dummy object used as the location/dimensions for the
//         : LensFlare client-side effect.
// --------------------------------

#include <stdio.h>

#include "de_server.h"
#include "lensflaresource.h"
#include "demo_msgtypes.h"

// Our simple lens flare source object

DDWORD LensFlareSource::EngineMessageFn(DDWORD messageID, void *pData, DFLOAT lData)
{
	HMESSAGEWRITE hWrite;

	switch(messageID)
	{
		// This is where the variables from the level editor are read.
		case MID_PRECREATE:
		{
			// We don't have any parameters, so we don't read anything here.
			// See the PolyGrid for an example of how to read stuff in this message.

			break;
		}

		// Our initial update.. 
		// Setup the special effect message.
		case MID_INITIALUPDATE:
		{
			// Send all our relevant data to the client.
			hWrite = GetServerDE()->StartSpecialEffectMessage(this);
			GetServerDE()->WriteToMessageByte(hWrite, DEMO_MSG_LENSFLARE_ADD);
			GetServerDE()->EndMessage(hWrite);
			break;
		}
	}

	// Pass the message on down to our parent.
	return BaseClass::EngineMessageFn(messageID, pData, lData);
}

// Class definition.
BEGIN_CLASS(LensFlareSource)
END_CLASS_DEFAULT(LensFlareSource, BaseClass, NULL, NULL)
